Index: t3lib/config_default.php
===================================================================
--- t3lib/config_default.php	(Revision 2438)
+++ t3lib/config_default.php	(Arbeitskopie)
@@ -269,7 +269,7 @@
 
 	// Include localconf.php. Use this file to configure TYPO3 for your needs and database
 if (!@is_file(PATH_typo3conf.'localconf.php'))	die('localconf.php is not found!');
-require(PATH_typo3conf.'localconf.php');
+require_once(PATH_typo3conf.'localconf.php');
 
 	// Defining the database setup as constants
 define('TYPO3_db', $typo_db);
@@ -403,14 +403,14 @@
 if (TYPO3_MODE=='FE' && is_object($TT)) $TT->push('Loading localconf.php extensions','');
 $TYPO3_LOADED_EXT = t3lib_extMgm::typo3_loadExtensions();
 if ($TYPO3_LOADED_EXT['_CACHEFILE'])	{
-	require(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
+	require_once(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
 } else {
 	$temp_TYPO3_LOADED_EXT = $TYPO3_LOADED_EXT;
 	reset($temp_TYPO3_LOADED_EXT);
 	while(list($_EXTKEY,$temp_lEDat)=each($temp_TYPO3_LOADED_EXT))	{
 		if (is_array($temp_lEDat) && $temp_lEDat['ext_localconf.php'])	{
 			$_EXTCONF = $TYPO3_CONF_VARS['EXT']['extConf'][$_EXTKEY];
-			require($temp_lEDat['ext_localconf.php']);
+			require_once($temp_lEDat['ext_localconf.php']);
 		}
 	}
 }
Index: t3lib/stddb/load_ext_tables.php
===================================================================
--- t3lib/stddb/load_ext_tables.php	(Revision 2438)
+++ t3lib/stddb/load_ext_tables.php	(Arbeitskopie)
@@ -15,7 +15,7 @@
 while(list($_EXTKEY,$temp_lEDat)=each($temp_TYPO3_LOADED_EXT))	{
 	if (is_array($temp_lEDat) && $temp_lEDat['ext_tables.php'])	{
 		$_EXTCONF = $TYPO3_CONF_VARS['EXT']['extConf'][$_EXTKEY];
-		require($temp_lEDat['ext_tables.php']);
+		require_once($temp_lEDat['ext_tables.php']);
 	}
 }
 ?>
\ Kein Zeilenvorschub am Ende der Datei
Index: t3lib/thumbs.php
===================================================================
--- t3lib/thumbs.php	(Revision 2438)
+++ t3lib/thumbs.php	(Arbeitskopie)
@@ -78,7 +78,7 @@
 require_once(PATH_t3lib.'class.t3lib_div.php');
 require_once(PATH_t3lib.'class.t3lib_extmgm.php');
 
-require(PATH_t3lib.'config_default.php');
+require_once(PATH_t3lib.'config_default.php');
 if (!defined ('TYPO3_db')) 	die ('The configuration file was not included.');
 if (!$TYPO3_CONF_VARS['GFX']['image_processing'])	die ('ImageProcessing was disabled!');
 
Index: typo3/alt_doc_ajax.php
===================================================================
--- typo3/alt_doc_ajax.php	(Revision 2438)
+++ typo3/alt_doc_ajax.php	(Arbeitskopie)
@@ -48,8 +48,8 @@
 
 
 
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_alt_doc.xml');
 require_once (PATH_t3lib.'class.t3lib_tceforms.php');
 	// @TODO: Do we really need this here?
Index: typo3/alt_shortcut.php
===================================================================
--- typo3/alt_shortcut.php	(Revision 2438)
+++ typo3/alt_shortcut.php	(Arbeitskopie)
@@ -65,8 +65,8 @@
  */
 
 
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_misc.xml');
 require_once(PATH_t3lib.'class.t3lib_loadmodules.php');
 require_once(PATH_t3lib.'class.t3lib_basicfilefunc.php');
Index: typo3/mod.php
===================================================================
--- typo3/mod.php	(Revision 2438)
+++ typo3/mod.php	(Arbeitskopie)
@@ -35,16 +35,16 @@
  */
 
 unset($MCONF);
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 
 	// Find module path:
 $temp_M = (string)t3lib_div::_GET('M');
 if ($temp_path = $TBE_MODULES['_PATHS'][$temp_M])	{
 	$MCONF['_'] = 'mod.php?M='.rawurlencode($temp_M);
-	require($temp_path.'conf.php');
+	require_once($temp_path.'conf.php');
 	$BACK_PATH='';
-	require($temp_path.'index.php');
+	require_once($temp_path.'index.php');
 } else {
 	#debug($TBE_MODULES);
 	die('Value "'.htmlspecialchars($temp_M).'" for "M" was not found as a module');
Index: typo3/alt_doc_nodoc.php
===================================================================
--- typo3/alt_doc_nodoc.php	(Revision 2438)
+++ typo3/alt_doc_nodoc.php	(Arbeitskopie)
@@ -49,8 +49,8 @@
  *
  */
 
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_alt_doc.xml');
 require_once(PATH_t3lib.'class.t3lib_loadmodules.php');
 
Index: typo3/alt_palette.php
===================================================================
--- typo3/alt_palette.php	(Revision 2438)
+++ typo3/alt_palette.php	(Arbeitskopie)
@@ -58,8 +58,8 @@
 
 
 
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once(PATH_t3lib.'class.t3lib_tceforms.php');
 require_once(PATH_t3lib.'class.t3lib_transferdata.php');
 require_once(PATH_t3lib.'class.t3lib_loaddbgroup.php');
Index: typo3/show_item.php
===================================================================
--- typo3/show_item.php	(Revision 2438)
+++ typo3/show_item.php	(Arbeitskopie)
@@ -57,8 +57,8 @@
 
 
 $BACK_PATH = '';
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 require_once(PATH_t3lib.'class.t3lib_page.php');
 require_once(PATH_t3lib.'class.t3lib_loaddbgroup.php');
 require_once(PATH_t3lib.'class.t3lib_transferdata.php');
Index: typo3/view_help.php
===================================================================
--- typo3/view_help.php	(Revision 2438)
+++ typo3/view_help.php	(Arbeitskopie)
@@ -74,8 +74,8 @@
  *
  */
 
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_view_help.xml');
 require_once(PATH_t3lib.'class.t3lib_loadmodules.php');
 require_once(PATH_t3lib.'class.t3lib_parsehtml.php');
Index: typo3/wizard_colorpicker.php
===================================================================
--- typo3/wizard_colorpicker.php	(Revision 2438)
+++ typo3/wizard_colorpicker.php	(Arbeitskopie)
@@ -58,8 +58,8 @@
 
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once(PATH_t3lib.'class.t3lib_stdgraphic.php');
 $LANG->includeLLFile('EXT:lang/locallang_wizards.xml');
 
Index: typo3/alt_db_navframe.php
===================================================================
--- typo3/alt_db_navframe.php	(Revision 2438)
+++ typo3/alt_db_navframe.php	(Arbeitskopie)
@@ -53,8 +53,8 @@
 
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once('class.webpagetree.php');
 
 
Index: typo3/alt_doc.php
===================================================================
--- typo3/alt_doc.php	(Revision 2438)
+++ typo3/alt_doc.php	(Arbeitskopie)
@@ -78,8 +78,8 @@
  */
 
 
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_alt_doc.xml');
 require_once (PATH_t3lib.'class.t3lib_tceforms.php');
 require_once (PATH_t3lib.'class.t3lib_clipboard.php');
Index: typo3/file_rename.php
===================================================================
--- typo3/file_rename.php	(Revision 2438)
+++ typo3/file_rename.php	(Arbeitskopie)
@@ -50,8 +50,8 @@
 
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once(PATH_t3lib.'class.t3lib_basicfilefunc.php');
 
 
Index: typo3/file_newfolder.php
===================================================================
--- typo3/file_newfolder.php	(Revision 2438)
+++ typo3/file_newfolder.php	(Arbeitskopie)
@@ -50,8 +50,8 @@
 
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once(PATH_t3lib.'class.t3lib_basicfilefunc.php');
 
 
Index: typo3/file_edit.php
===================================================================
--- typo3/file_edit.php	(Revision 2438)
+++ typo3/file_edit.php	(Arbeitskopie)
@@ -49,8 +49,8 @@
  */
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once(PATH_t3lib.'class.t3lib_basicfilefunc.php');
 
 
Index: typo3/mod/tools/em/class.em_index.php
===================================================================
--- typo3/mod/tools/em/class.em_index.php	(Revision 2438)
+++ typo3/mod/tools/em/class.em_index.php	(Arbeitskopie)
@@ -1645,20 +1645,20 @@
 
 		$TYPO3_LOADED_EXT = t3lib_extMgm::typo3_loadExtensions();
 		if ($TYPO3_LOADED_EXT['_CACHEFILE'])    {
-			require(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
+			require_once(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
 		}
 		return;
 
 		$GLOBALS['TYPO3_LOADED_EXT'] = t3lib_extMgm::typo3_loadExtensions();
 		if ($TYPO3_LOADED_EXT['_CACHEFILE'])    {
-			require(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
+			require_once(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
 		} else {
 			$temp_TYPO3_LOADED_EXT = $TYPO3_LOADED_EXT;
 			reset($temp_TYPO3_LOADED_EXT);
 			while(list($_EXTKEY,$temp_lEDat)=each($temp_TYPO3_LOADED_EXT))  {
 				if (is_array($temp_lEDat) && $temp_lEDat['ext_localconf.php'])  {
 					$_EXTCONF = $TYPO3_CONF_VARS['EXT']['extConf'][$_EXTKEY];
-					require($temp_lEDat['ext_localconf.php']);
+					require_once($temp_lEDat['ext_localconf.php']);
 				}
 			}
 		}
Index: typo3/mod/tools/em/index.php
===================================================================
--- typo3/mod/tools/em/index.php	(Revision 2438)
+++ typo3/mod/tools/em/index.php	(Arbeitskopie)
@@ -36,9 +36,9 @@
 
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 $BE_USER->modAccess($MCONF,1);
 
 require_once('class.em_index.php');
Index: typo3/mod/web/perm/index.php
===================================================================
--- typo3/mod/web/perm/index.php	(Revision 2438)
+++ typo3/mod/web/perm/index.php	(Arbeitskopie)
@@ -60,9 +60,9 @@
  */
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 $LANG->includeLLFile('EXT:lang/locallang_mod_web_perm.xml');
 require_once (PATH_t3lib.'class.t3lib_pagetree.php');
 require_once (PATH_t3lib.'class.t3lib_page.php');
Index: typo3/mod/web/func/index.php
===================================================================
--- typo3/mod/web/func/index.php	(Revision 2438)
+++ typo3/mod/web/func/index.php	(Arbeitskopie)
@@ -50,9 +50,9 @@
 
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 $LANG->includeLLFile('EXT:lang/locallang_mod_web_func.xml');
 require_once(PATH_t3lib.'class.t3lib_scbase.php');
 
Index: typo3/mod/web/info/index.php
===================================================================
--- typo3/mod/web/info/index.php	(Revision 2438)
+++ typo3/mod/web/info/index.php	(Arbeitskopie)
@@ -49,9 +49,9 @@
  */
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 $LANG->includeLLFile('EXT:lang/locallang_mod_web_info.xml');
 require_once (PATH_t3lib.'class.t3lib_scbase.php');
 
Index: typo3/mod/user/ws/workspaceforms.php
===================================================================
--- typo3/mod/user/ws/workspaceforms.php	(Revision 2438)
+++ typo3/mod/user/ws/workspaceforms.php	(Arbeitskopie)
@@ -69,9 +69,9 @@
 
 // Initialize module:
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 $BE_USER->modAccess($MCONF,1);
 
 // Include libraries of various kinds used inside:
Index: typo3/mod/user/ws/wsol_preview.php
===================================================================
--- typo3/mod/user/ws/wsol_preview.php	(Revision 2438)
+++ typo3/mod/user/ws/wsol_preview.php	(Arbeitskopie)
@@ -45,8 +45,8 @@
 define('TYPO3_PROCEED_IF_NO_USER', '1');
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
 require_once('class.wslib.php');
 
 
Index: typo3/mod/user/ws/publish.php
===================================================================
--- typo3/mod/user/ws/publish.php	(Revision 2438)
+++ typo3/mod/user/ws/publish.php	(Arbeitskopie)
@@ -54,9 +54,9 @@
 
 // Initialize module:
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH . 'init.php');
-require($BACK_PATH . 'template.php');
+require_once('conf.php');
+require_once($BACK_PATH . 'init.php');
+require_once($BACK_PATH . 'template.php');
 $BE_USER->modAccess($MCONF, 1);
 
 // Include libraries of various kinds used inside:
Index: typo3/alt_file_navframe.php
===================================================================
--- typo3/alt_file_navframe.php	(Revision 2438)
+++ typo3/alt_file_navframe.php	(Arbeitskopie)
@@ -55,8 +55,8 @@
  */
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 require_once('class.filelistfoldertree.php');
 
 
Index: typo3/db_new.php
===================================================================
--- typo3/db_new.php	(Revision 2438)
+++ typo3/db_new.php	(Arbeitskopie)
@@ -65,8 +65,8 @@
 
 
 $BACK_PATH='';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_misc.xml');
 
 // ***************************
Index: typo3/init.php
===================================================================
--- typo3/init.php	(Revision 2438)
+++ typo3/init.php	(Arbeitskopie)
@@ -155,7 +155,7 @@
 // ****************************************************
 // Include configuration (localconf + ext_localconf)
 // ****************************************************
-require(PATH_t3lib.'config_default.php');
+require_once(PATH_t3lib.'config_default.php');
 if (!defined ('TYPO3_db')) 	die ('The configuration file was not included.');
 
 require_once(PATH_t3lib.'class.t3lib_db.php');		// The database library
Index: typo3/sysext/lowlevel/dbint/cli/cleaner_cli.php
===================================================================
--- typo3/sysext/lowlevel/dbint/cli/cleaner_cli.php	(Revision 2438)
+++ typo3/sysext/lowlevel/dbint/cli/cleaner_cli.php	(Arbeitskopie)
@@ -5,7 +5,7 @@
 require_once(PATH_t3lib.'class.t3lib_refindex.php');
 require_once(t3lib_extMgm::extPath('lowlevel').'class.tx_lowlevel_cleaner_core.php');
 
-require(PATH_typo3.'template.php');
+require_once(PATH_typo3.'template.php');
 
 	// Call the functionality
 $cleanerObj = t3lib_div::makeInstance('tx_lowlevel_cleaner_core');
Index: typo3/sysext/cms/tslib/index_ts.php
===================================================================
--- typo3/sysext/cms/tslib/index_ts.php	(Revision 2438)
+++ typo3/sysext/cms/tslib/index_ts.php	(Arbeitskopie)
@@ -92,7 +92,7 @@
 // Include configuration
 // **********************
 $TT->push('Include config files','');
-require(PATH_t3lib.'config_default.php');
+require_once(PATH_t3lib.'config_default.php');
 if (!defined ('TYPO3_db')) 	die ('The configuration file was not included.');	// the name of the TYPO3 database is stored in this constant. Here the inclusion of the config-file is verified by checking if this var is set.
 if (!t3lib_extMgm::isLoaded('cms'))	die('<strong>Error:</strong> The main frontend extension "cms" was not loaded. Enable it in the extension manager in the backend.');
 
@@ -130,7 +130,7 @@
 if ($temp_extId = t3lib_div::_GP('eID'))	{
 	if ($classPath = t3lib_div::getFileAbsFileName($TYPO3_CONF_VARS['FE']['eID_include'][$temp_extId]))	{
 		require_once(PATH_tslib.'class.tslib_eidtools.php');
-		require($classPath);
+		require_once($classPath);
 	}
 	exit;
 }
Index: typo3/sysext/cms/layout/db_layout.php
===================================================================
--- typo3/sysext/cms/layout/db_layout.php	(Revision 2438)
+++ typo3/sysext/cms/layout/db_layout.php	(Arbeitskopie)
@@ -68,9 +68,9 @@
 
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 $LANG->includeLLFile('EXT:cms/layout/locallang.xml');
 require_once(PATH_t3lib.'class.t3lib_pagetree.php');
 require_once(PATH_t3lib.'class.t3lib_page.php');
Index: typo3/sysext/cms/layout/db_new_content_el.php
===================================================================
--- typo3/sysext/cms/layout/db_new_content_el.php	(Revision 2438)
+++ typo3/sysext/cms/layout/db_new_content_el.php	(Arbeitskopie)
@@ -61,9 +61,9 @@
 
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 
 	// Unset MCONF/MLANG since all we wanted was back path etc. for this particular script.
 unset($MCONF);
Index: typo3/sysext/setup/mod/index.php
===================================================================
--- typo3/sysext/setup/mod/index.php	(Revision 2438)
+++ typo3/sysext/setup/mod/index.php	(Arbeitskopie)
@@ -59,8 +59,8 @@
  */
 
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
 require_once(PATH_t3lib.'class.t3lib_tcemain.php');
 require_once(PATH_t3lib.'class.t3lib_loadmodules.php');
 
Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(Revision 2438)
+++ typo3/sysext/install/mod/class.tx_install.php	(Arbeitskopie)
@@ -3908,7 +3908,7 @@
 		$GLOBALS['TYPO3_CONF_VARS']['EXT']['extCache'] = 1;
 		$TYPO3_LOADED_EXT = t3lib_extMgm::typo3_loadExtensions();
 		if ($TYPO3_LOADED_EXT['_CACHEFILE'])	{
-			require(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
+			require_once(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
 		}
 
 			// call wizard
Index: typo3/sysext/rtehtmlarea/mod2/acronym.php
===================================================================
--- typo3/sysext/rtehtmlarea/mod2/acronym.php	(Revision 2438)
+++ typo3/sysext/rtehtmlarea/mod2/acronym.php	(Arbeitskopie)
@@ -34,9 +34,9 @@
 
 error_reporting (E_ALL ^ E_NOTICE);
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 require_once('class.tx_rtehtmlarea_acronym.php');
 $LANG->includeLLFile('EXT:rtehtmlarea/mod2/locallang.xml');
 $LANG->includeLLFile('EXT:rtehtmlarea/htmlarea/locallang_dialogs.xml');
Index: typo3/sysext/rtehtmlarea/mod3/browse_links.php
===================================================================
--- typo3/sysext/rtehtmlarea/mod3/browse_links.php	(Revision 2438)
+++ typo3/sysext/rtehtmlarea/mod3/browse_links.php	(Arbeitskopie)
@@ -40,9 +40,9 @@
 
 error_reporting (E_ALL ^ E_NOTICE);
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 require_once('class.tx_rtehtmlarea_browse_links.php');
 $LANG->includeLLFile('EXT:rtehtmlarea/mod3/locallang.xml');
 $LANG->includeLLFile('EXT:rtehtmlarea/htmlarea/locallang_dialogs.xml');
Index: typo3/sysext/rtehtmlarea/mod4/select_image.php
===================================================================
--- typo3/sysext/rtehtmlarea/mod4/select_image.php	(Revision 2438)
+++ typo3/sysext/rtehtmlarea/mod4/select_image.php	(Arbeitskopie)
@@ -36,9 +36,9 @@
 
 error_reporting (E_ALL ^ E_NOTICE);
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 require_once('class.tx_rtehtmlarea_select_image.php');
 $LANG->includeLLFile('EXT:lang/locallang_browse_links.xml');
 $LANG->includeLLFile('EXT:rtehtmlarea/mod4/locallang.xml');
Index: typo3/sysext/rtehtmlarea/mod5/user.php
===================================================================
--- typo3/sysext/rtehtmlarea/mod5/user.php	(Revision 2438)
+++ typo3/sysext/rtehtmlarea/mod5/user.php	(Arbeitskopie)
@@ -36,9 +36,9 @@
 
 error_reporting (E_ALL ^ E_NOTICE);
 unset($MCONF);
-require('conf.php');
-require($BACK_PATH.'init.php');
-require($BACK_PATH.'template.php');
+require_once('conf.php');
+require_once($BACK_PATH.'init.php');
+require_once($BACK_PATH.'template.php');
 require_once('class.tx_rtehtmlarea_user.php');
 $LANG->includeLLFile('EXT:rtehtmlarea/mod5/locallang.xml');
 $LANG->includeLLFile('EXT:rtehtmlarea/htmlarea/locallang_dialogs.xml');
Index: typo3/sysext/adodb/adodb/adodb-xmlschema.inc.php
===================================================================
--- typo3/sysext/adodb/adodb/adodb-xmlschema.inc.php	(Revision 2438)
+++ typo3/sysext/adodb/adodb/adodb-xmlschema.inc.php	(Arbeitskopie)
@@ -92,8 +92,8 @@
 * Include the main ADODB library
 */
 if( !defined( '_ADODB_LAYER' ) ) {
-	require( 'adodb.inc.php' );
-	require( 'adodb-datadict.inc.php' );
+	require_once( 'adodb.inc.php' );
+	require_once( 'adodb-datadict.inc.php' );
 }
 
 /**
Index: typo3/sysext/adodb/adodb/adodb-xmlschema03.inc.php
===================================================================
--- typo3/sysext/adodb/adodb/adodb-xmlschema03.inc.php	(Revision 2438)
+++ typo3/sysext/adodb/adodb/adodb-xmlschema03.inc.php	(Arbeitskopie)
@@ -110,8 +110,8 @@
 * Include the main ADODB library
 */
 if( !defined( '_ADODB_LAYER' ) ) {
-	require( 'adodb.inc.php' );
-	require( 'adodb-datadict.inc.php' );
+	require_once( 'adodb.inc.php' );
+	require_once( 'adodb-datadict.inc.php' );
 }
 
 /**
Index: typo3/file_upload.php
===================================================================
--- typo3/file_upload.php	(Revision 2438)
+++ typo3/file_upload.php	(Arbeitskopie)
@@ -50,8 +50,8 @@
 
 
 $BACK_PATH = '';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 $LANG->includeLLFile('EXT:lang/locallang_misc.xml');
 require_once(PATH_t3lib.'class.t3lib_basicfilefunc.php');
 
Index: typo3/move_el.php
===================================================================
--- typo3/move_el.php	(Revision 2438)
+++ typo3/move_el.php	(Arbeitskopie)
@@ -66,8 +66,8 @@
 
 
 $BACK_PATH='';
-require('init.php');
-require('template.php');
+require_once('init.php');
+require_once('template.php');
 
 	// Include local language labels:
 $LANG->includeLLFile('EXT:lang/locallang_misc.xml');