Index: typo3/sysext/css_styled_content/static/setup.txt
===================================================================
--- typo3/sysext/css_styled_content/static/setup.txt	(Revision 2450)
+++ typo3/sysext/css_styled_content/static/setup.txt	(Arbeitskopie)
@@ -37,7 +37,7 @@
 	10 = EDITPANEL
 	10 {
 		allow = toolbar,move,hide
-		label.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.page
+		label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.page
 		label.wrap = |&nbsp;<b>%s</b>
 	}
 }
@@ -204,7 +204,7 @@
 
 	stdWrap.editIcons = tt_content : header, [header_layout | header_position], [header_link|date]
 	stdWrap.editIcons.beforeLastTag = 1
-	stdWrap.editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.header
+	stdWrap.editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.header
 
 	stdWrap.dataWrap = <div class="csc-header csc-header-n{cObj:parentRecordNumber}">|</div>
 	stdWrap.prefixComment = 2 | Header:
@@ -276,7 +276,7 @@
 		21.value = <div class="csc-frame csc-frame-frame2">|</div>
 	}
 
-	innerWrap2 = | <p class="csc-linkToTop"><a href="#">{LLL:EXT:css_styled_content/pi1/locallang.php:label.toTop}</a></p>
+	innerWrap2 = | <p class="csc-linkToTop"><a href="#">{LLL:EXT:css_styled_content/pi1/locallang.xml:label.toTop}</a></p>
 	innerWrap2.insertData = 1
 	innerWrap2.fieldRequired = linkToTop
 
@@ -318,7 +318,7 @@
 
 		editIcons = tt_content:subheader,layout
 		editIcons.beforeLastTag = 1
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.subheader
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.subheader
 
 		prefixComment = 2 | Subheader:
 	}
@@ -341,7 +341,7 @@
 
 		editIcons = tt_content:bodytext, rte_enabled
 		editIcons.beforeLastTag = 1
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.bodytext
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.bodytext
 
 		prefixComment = 2 | Text:
 	}
@@ -447,11 +447,11 @@
 	textMargin = {$styles.content.imgtext.textMargin}
 
 	editIcons = tt_content : image [imageorient|imagewidth|imageheight], [imagecols|image_noRows|imageborder],[image_link|image_zoom],[image_compression|image_effects|image_frames],imagecaption[imagecaption_position]
-	editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.images
+	editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.images
 
 	caption.editIcons = tt_content : imagecaption[imagecaption_position]
 	caption.editIcons.beforeLastTag=1
-	caption.editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.caption
+	caption.editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.caption
 
 	stdWrap.prefixComment = 2 | Image block:
 }
@@ -495,7 +495,7 @@
 	20.stdWrap {
 		editIcons = tt_content: bodytext, [layout]
 		editIcons.beforeLastTag = 1
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.bullets
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.bullets
 
 		prefixComment = 2 | Bullet list:
 	}
@@ -544,7 +544,7 @@
 	20.stdWrap {
 		editIcons = tt_content: cols, bodytext, [layout], [table_bgColor|table_border|table_cellspacing|table_cellpadding]
 		editIcons.beforeLastTag = 1
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.table
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.table
 
 		prefixComment = 2 | Table:
 	}
@@ -602,7 +602,7 @@
 
 	20.stdWrap {
 		editIcons = tt_content: media, layout [table_bgColor|table_border|table_cellspacing|table_cellpadding], filelink_size, imagecaption
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.filelist
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.filelist
 
 		prefixComment = 2 | File list:
 	}
@@ -624,7 +624,7 @@
 
 	20.stdWrap {
 		editIcons = tt_content: multimedia, bodytext
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.multimedia
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.multimedia
 
 		prefixComment = 2 | Multimedia element:
 	}
@@ -657,7 +657,7 @@
 	stdWrap.wrap = <table border="0" cellspacing="1" cellpadding="1" class="csc-mailform">  | </table>
 	stdWrap {
 		editIcons = tt_content: bodytext, pages, subheader
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.form
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.form
 
 		prefixComment = 2 | Mail form inserted:
 	}
@@ -706,7 +706,7 @@
 		wrap = <table border="0" cellspacing="0" cellpadding="2" class="csc-searchResultInfo"><tr> | </tr></table> ###RESULT###
 
 		10 = TEXT
-		10.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.resultRange
+		10.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.resultRange
 		10.wrap = <td class="csc-searchResultRange"><p>|</p></td>
 
 		20 = TEXT
@@ -717,15 +717,15 @@
 	noResultObj = COA
 	noResultObj {
 		10 = TEXT
-		10.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.emptySearch
+		10.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.emptySearch
 		10.wrap = <h3 class="csc-noSearchResultMsg">|</h3>
 	}
 
 	next = TEXT
-	next.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.searchResultNext
+	next.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.searchResultNext
 
 	prev = TEXT
-	prev.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.searchResultPrev
+	prev.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.searchResultPrev
 
 	target = {$styles.content.searchresult.target}
 	range = 20
@@ -741,20 +741,20 @@
 	recipient >
 	data >
 	dataArray {
-		10.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.searchWord
+		10.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.searchWord
 		10.type = sword=input
-		20.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.searchIn
+		20.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.searchIn
 		20.type = scols=select
 		20.valueArray {
-			10.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.headersKeywords
+			10.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.headersKeywords
 			10.value = pages.title-subtitle-keywords-description:tt_content.header
-			20.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.pageContent
+			20.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.pageContent
 			20.value = tt_content.header-bodytext-imagecaption
 		}
 		30.type = stype=hidden
 		30.value = L0
 		40.type = submit=submit
-		40.value.data = LLL:EXT:css_styled_content/pi1/locallang.php:search.searchButton
+		40.value.data = LLL:EXT:css_styled_content/pi1/locallang.xml:search.searchButton
 	}
 	type.field = pages
 	type.listNum = 0
@@ -763,7 +763,7 @@
 
 	stdWrap.wrap = <table border="0" cellspacing="1" cellpadding="1" class="csc-searchform">  | </table>
 	stdWrap {
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.search
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.search
 
 		prefixComment = 2 | Search form inserted:
 	}
@@ -781,14 +781,14 @@
 	recipient >
 	data >
 	dataArray {
-		10.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:login.username
+		10.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:login.username
 		10.type = *user=input
-		20.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:login.password
+		20.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:login.password
 		20.type = *pass=password
 		30.type = logintype=hidden
 		30.value = login
 		40.type = submit=submit
-		40.value.data = LLL:EXT:css_styled_content/pi1/locallang.php:login.login
+		40.value.data = LLL:EXT:css_styled_content/pi1/locallang.xml:login.login
 	}
 	type.field = pages
 	type.listNum = 0
@@ -803,7 +803,7 @@
 
 	stdWrap.wrap = <table border="0" cellspacing="1" cellpadding="1" class="csc-loginform">  | </table>
 	stdWrap {
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.login
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.login
 
 		prefixComment = 2 | Login/Logout form:
 	}
@@ -812,12 +812,12 @@
 tt_content.login.20 {
 	dataArray >
 	dataArray {
-		10.label.data = LLL:EXT:css_styled_content/pi1/locallang.php:login.username
+		10.label.data = LLL:EXT:css_styled_content/pi1/locallang.xml:login.username
 		10.label.wrap = |&nbsp;<!--###USERNAME###-->
 		30.type = logintype=hidden
 		30.value = logout
 		40.type = submit=submit
-		40.value.data = LLL:EXT:css_styled_content/pi1/locallang.php:login.logout
+		40.value.data = LLL:EXT:css_styled_content/pi1/locallang.xml:login.logout
 	}
 }
 [global]
@@ -988,7 +988,7 @@
 
 	20.stdWrap {
 		editIcons = tt_content: menu_type, pages
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.menuSitemap
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.menuSitemap
 
 		prefixComment = 2 | Menu/Sitemap element:
 	}
@@ -1029,7 +1029,7 @@
 
 	20.stdWrap {
 		editIcons = tt_content: records
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.recordList
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.recordList
 
 		prefixComment = 2 | Inclusion of other records (by reference):
 	}
@@ -1093,7 +1093,7 @@
 
 	20.stdWrap {
 		editIcons = tt_content: list_type, layout, select_key, pages [recursive]
-		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.plugin
+		editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.plugin
 
 		prefixComment = 2 | Plugin inserted:
 	}
@@ -1132,7 +1132,7 @@
 	field = bodytext
 
 	editIcons = tt_content: pages
-	editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.php:eIcon.html
+	editIcons.iconTitle.data = LLL:EXT:css_styled_content/pi1/locallang.xml:eIcon.html
 
 	prefixComment = 2 | Raw HTML content:
 }
Index: typo3/sysext/css_styled_content/ext_emconf.php
===================================================================
--- typo3/sysext/css_styled_content/ext_emconf.php	(Revision 2450)
+++ typo3/sysext/css_styled_content/ext_emconf.php	(Arbeitskopie)
@@ -2,14 +2,15 @@
 
 ########################################################################
 # Extension Manager/Repository config file for ext: "css_styled_content"
-# 
-# Auto generated 17-11-2004 17:47
-# 
+#
+# Auto generated 19-08-2007 14:39
+#
 # Manual updates:
-# Only the data in the array - anything else is removed by next write
+# Only the data in the array - anything else is removed by next write.
+# "version" and "dependencies" must not be touched!
 ########################################################################
 
-$EM_CONF[$_EXTKEY] = Array (
+$EM_CONF[$_EXTKEY] = array(
 	'title' => 'CSS styled content',
 	'description' => 'Contains configuration for CSS content-rendering of the table "tt_content". This is meant as a modern substitute for the classic "content (default)" template which was based more on <font>-tags, while this is pure CSS. It is intended to work with all modern browsers (which excludes the NS4 series).',
 	'category' => 'fe',
@@ -18,8 +19,6 @@
 	'conflicts' => '',
 	'priority' => 'top',
 	'loadOrder' => '',
-	'TYPO3_version' => '3.7.0-',
-	'PHP_version' => '0.0.1-0.0.1',
 	'module' => '',
 	'state' => 'beta',
 	'internal' => 1,
@@ -33,10 +32,19 @@
 	'author_company' => 'Curby Soft Multimedia',
 	'CGLcompliance' => '',
 	'CGLcompliance_note' => '',
-	'private' => 0,
-	'download_password' => '',
-	'version' => '0.3.1',	// Don't modify this! Managed automatically during upload to repository.
-	'_md5_values_when_last_written' => 'a:36:{s:21:"ext_conf_template.txt";s:4:"44ff";s:12:"ext_icon.gif";s:4:"1845";s:17:"ext_localconf.php";s:4:"b9d5";s:15:"ext_php_api.dat";s:4:"f62a";s:14:"ext_tables.php";s:4:"c1f8";s:16:"pageTSconfig.txt";s:4:"a3eb";s:11:"CVS/Entries";s:4:"4fb6";s:14:"CVS/Repository";s:4:"96d6";s:8:"CVS/Root";s:4:"0ea2";s:12:"doc/TODO.txt";s:4:"6534";s:14:"doc/manual.sxw";s:4:"85e4";s:15:"doc/CVS/Entries";s:4:"0a8a";s:18:"doc/CVS/Repository";s:4:"e39c";s:12:"doc/CVS/Root";s:4:"0ea2";s:37:"pi1/class.tx_cssstyledcontent_pi1.php";s:4:"8ab0";s:17:"pi1/locallang.php";s:4:"79d0";s:15:"pi1/CVS/Entries";s:4:"43e7";s:18:"pi1/CVS/Repository";s:4:"07e9";s:12:"pi1/CVS/Root";s:4:"0ea2";s:20:"static/constants.txt";s:4:"ff7a";s:20:"static/editorcfg.txt";s:4:"8d1c";s:16:"static/setup.txt";s:4:"49b4";s:18:"static/CVS/Entries";s:4:"2f1f";s:21:"static/CVS/Repository";s:4:"64f2";s:15:"static/CVS/Root";s:4:"0ea2";s:15:"css/example.css";s:4:"9804";s:24:"css/example_outlines.css";s:4:"e656";s:14:"css/readme.txt";s:4:"af18";s:15:"css/CVS/Entries";s:4:"bc3d";s:18:"css/CVS/Repository";s:4:"1c6e";s:12:"css/CVS/Root";s:4:"0ea2";s:31:"css/img/background_gradient.gif";s:4:"45d7";s:28:"css/img/red_arrow_bullet.gif";s:4:"82d6";s:19:"css/img/CVS/Entries";s:4:"a4f6";s:22:"css/img/CVS/Repository";s:4:"3aff";s:16:"css/img/CVS/Root";s:4:"0ea2";}',
+	'version' => '0.3.2',
+	'_md5_values_when_last_written' => 'a:19:{s:21:"ext_conf_template.txt";s:4:"6bbb";s:12:"ext_icon.gif";s:4:"1845";s:17:"ext_localconf.php";s:4:"37eb";s:14:"ext_tables.php";s:4:"6ffa";s:15:"flexform_ds.xml";s:4:"6f8f";s:16:"locallang_db.xml";s:4:"0284";s:16:"pageTSconfig.txt";s:4:"5cbc";s:12:"doc/TODO.txt";s:4:"6534";s:14:"doc/manual.sxw";s:4:"0179";s:20:"static/constants.txt";s:4:"ad6c";s:20:"static/editorcfg.txt";s:4:"a3c7";s:16:"static/setup.txt";s:4:"3506";s:15:"css/example.css";s:4:"9804";s:24:"css/example_outlines.css";s:4:"e656";s:14:"css/readme.txt";s:4:"ee9d";s:31:"css/img/background_gradient.gif";s:4:"45d7";s:28:"css/img/red_arrow_bullet.gif";s:4:"82d6";s:37:"pi1/class.tx_cssstyledcontent_pi1.php";s:4:"3ce2";s:17:"pi1/locallang.xml";s:4:"974c";}',
+	'constraints' => array(
+		'depends' => array(
+			'cms' => '',
+			'php' => '4.3.0-0.0.0',
+			'typo3' => '4.1.0-0.0.0',
+		),
+		'conflicts' => array(
+		),
+		'suggests' => array(
+		),
+	),
 );
 
 ?>
\ Kein Zeilenvorschub am Ende der Datei